# coding: utf-8

"""
    Price

    This service offers the ability to retrieve security prices via specifying a price hierarchy or price purpose. This can be used to retrieve a single price for a specific date, time series of prices for a date range, or month-end prices for a date range.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_data.agraph.data.market_data.price.v2.PricingAPI.models.enums_return_response import EnumsReturnResponse
from asdk_plugin_data.agraph.data.market_data.price.v2.PricingAPI.models.v2_asset_price import V2AssetPrice

class V2FilterAssetPricesPurposesResponse(BaseModel):
    """
    V2FilterAssetPricesPurposesResponse
    """
    asset_prices: Optional[conlist(V2AssetPrice)] = Field(None, alias="assetPrices")
    return_code: Optional[EnumsReturnResponse] = Field(None, alias="returnCode")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token, which can be sent as 'page_token' to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    __properties = ["assetPrices", "returnCode", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V2FilterAssetPricesPurposesResponse:
        """Create an instance of V2FilterAssetPricesPurposesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in asset_prices (list)
        _items = []
        if self.asset_prices:
            for _item in self.asset_prices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['assetPrices'] = _items
        # override the default output from pydantic by calling `to_dict()` of return_code
        if self.return_code:
            _dict['returnCode'] = self.return_code.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V2FilterAssetPricesPurposesResponse:
        """Create an instance of V2FilterAssetPricesPurposesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V2FilterAssetPricesPurposesResponse.parse_obj(obj)

        _obj = V2FilterAssetPricesPurposesResponse.parse_obj({
            "asset_prices": [V2AssetPrice.from_dict(_item) for _item in obj.get("assetPrices")] if obj.get("assetPrices") is not None else None,
            "return_code": EnumsReturnResponse.from_dict(obj.get("returnCode")) if obj.get("returnCode") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

