# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, conlist
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_accrual_base import EnumsAccrualBase
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_cash_time_deposit_class import EnumsCashTimeDepositClass
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_cash_time_deposit_rate_type import EnumsCashTimeDepositRateType
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_cash_time_deposit_structure import EnumsCashTimeDepositStructure
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_coupon_calc_method import EnumsCouponCalcMethod
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_frequency_type import EnumsFrequencyType
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_lookback_type import EnumsLookbackType
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_registration import EnumsRegistration

class ReferenceDataassetv1CashTimeDepositSecurity(BaseModel):
    """
    ReferenceDataassetv1CashTimeDepositSecurity
    """
    currency_code: Optional[StrictStr] = Field(None, alias="currencyCode")
    country_code: Optional[StrictStr] = Field(None, alias="countryCode")
    market_country_code: Optional[StrictStr] = Field(None, alias="marketCountryCode")
    accrual_base: Optional[EnumsAccrualBase] = Field(None, alias="accrualBase")
    accrual_date: Optional[date] = Field(None, alias="accrualDate")
    maturity_date: Optional[date] = Field(None, alias="maturityDate")
    first_coupon_date: Optional[date] = Field(None, alias="firstCouponDate")
    rate_type: Optional[EnumsCashTimeDepositRateType] = Field(None, alias="rateType")
    rate: Optional[Union[StrictFloat, StrictInt]] = None
    initial_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="initialRate")
    payment_frequency_type: Optional[EnumsFrequencyType] = Field(None, alias="paymentFrequencyType")
    payment_calendar_codes: Optional[conlist(StrictStr)] = Field(None, alias="paymentCalendarCodes", description="Calendar used for determining business days for payments Represents AUCK, BG, Brazil, CA etc If multiple calendars are chosen, they represents OR relation ship, meaning if it's a business on any of the chosen calendars, it's considered a business day.")
    security_description: Optional[EnumsCashTimeDepositClass] = Field(None, alias="securityDescription")
    registration: Optional[EnumsRegistration] = None
    registration_right: Optional[StrictBool] = Field(None, alias="registrationRight")
    liquidity: Optional[StrictBool] = None
    structure: Optional[EnumsCashTimeDepositStructure] = None
    reset_frequency_type: Optional[EnumsFrequencyType] = Field(None, alias="resetFrequencyType")
    reset_calendar_codes: Optional[conlist(StrictStr)] = Field(None, alias="resetCalendarCodes", description="Calendar used for determining business days for resets Represents AUCK, BG, Brazil, CA etc If multiple calendars are chosen, they represents OR relation ship, meaning if it's a business on any of the chosen calendars, it's considered a business day.")
    compounding: Optional[StrictBool] = None
    reset_index: Optional[StrictStr] = Field(None, alias="resetIndex")
    spread: Optional[Union[StrictFloat, StrictInt]] = None
    lookback_calendar_codes: Optional[conlist(StrictStr)] = Field(None, alias="lookbackCalendarCodes", description="Lookback calendar to calculate lookback Represents AUCK, BG, Brazil, CA etc If multiple calendars are chosen, they represents OR relation ship, meaning if it's a business on any of the chosen calendars, it's considered a business day.")
    lookback_type: Optional[EnumsLookbackType] = Field(None, alias="lookbackType")
    look_back_day_count: Optional[StrictInt] = Field(None, alias="lookBackDayCount", description="Lookback days used to describe the lag in days between the determination date of the index rate and the actual date the index was reset Lookback is in terms of Business days.")
    lockout_day_count: Optional[StrictInt] = Field(None, alias="lockoutDayCount")
    coupon_calculation_method: Optional[EnumsCouponCalcMethod] = Field(None, alias="couponCalculationMethod")
    counterparty: Optional[StrictStr] = None
    __properties = ["currencyCode", "countryCode", "marketCountryCode", "accrualBase", "accrualDate", "maturityDate", "firstCouponDate", "rateType", "rate", "initialRate", "paymentFrequencyType", "paymentCalendarCodes", "securityDescription", "registration", "registrationRight", "liquidity", "structure", "resetFrequencyType", "resetCalendarCodes", "compounding", "resetIndex", "spread", "lookbackCalendarCodes", "lookbackType", "lookBackDayCount", "lockoutDayCount", "couponCalculationMethod", "counterparty"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReferenceDataassetv1CashTimeDepositSecurity:
        """Create an instance of ReferenceDataassetv1CashTimeDepositSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReferenceDataassetv1CashTimeDepositSecurity:
        """Create an instance of ReferenceDataassetv1CashTimeDepositSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReferenceDataassetv1CashTimeDepositSecurity.parse_obj(obj)

        _obj = ReferenceDataassetv1CashTimeDepositSecurity.parse_obj({
            "currency_code": obj.get("currencyCode"),
            "country_code": obj.get("countryCode"),
            "market_country_code": obj.get("marketCountryCode"),
            "accrual_base": obj.get("accrualBase"),
            "accrual_date": obj.get("accrualDate"),
            "maturity_date": obj.get("maturityDate"),
            "first_coupon_date": obj.get("firstCouponDate"),
            "rate_type": obj.get("rateType"),
            "rate": obj.get("rate"),
            "initial_rate": obj.get("initialRate"),
            "payment_frequency_type": obj.get("paymentFrequencyType"),
            "payment_calendar_codes": obj.get("paymentCalendarCodes"),
            "security_description": obj.get("securityDescription"),
            "registration": obj.get("registration"),
            "registration_right": obj.get("registrationRight"),
            "liquidity": obj.get("liquidity"),
            "structure": obj.get("structure"),
            "reset_frequency_type": obj.get("resetFrequencyType"),
            "reset_calendar_codes": obj.get("resetCalendarCodes"),
            "compounding": obj.get("compounding"),
            "reset_index": obj.get("resetIndex"),
            "spread": obj.get("spread"),
            "lookback_calendar_codes": obj.get("lookbackCalendarCodes"),
            "lookback_type": obj.get("lookbackType"),
            "look_back_day_count": obj.get("lookBackDayCount"),
            "lockout_day_count": obj.get("lockoutDayCount"),
            "coupon_calculation_method": obj.get("couponCalculationMethod"),
            "counterparty": obj.get("counterparty")
        })
        return _obj

