# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_call_put_type import EnumsCallPutType
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.type_month import TypeMonth

class ReferenceDataassetv1FuturesSecurity(BaseModel):
    """
    ReferenceDataassetv1FuturesSecurity
    """
    ric: Optional[StrictStr] = None
    contract_name: Optional[StrictStr] = Field(None, alias="contractName")
    contract_year: Optional[StrictStr] = Field(None, alias="contractYear")
    contract_month: Optional[TypeMonth] = Field(None, alias="contractMonth")
    strike: Optional[Union[StrictFloat, StrictInt]] = None
    call_put_type: Optional[EnumsCallPutType] = Field(None, alias="callPutType")
    __properties = ["ric", "contractName", "contractYear", "contractMonth", "strike", "callPutType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReferenceDataassetv1FuturesSecurity:
        """Create an instance of ReferenceDataassetv1FuturesSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReferenceDataassetv1FuturesSecurity:
        """Create an instance of ReferenceDataassetv1FuturesSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReferenceDataassetv1FuturesSecurity.parse_obj(obj)

        _obj = ReferenceDataassetv1FuturesSecurity.parse_obj({
            "ric": obj.get("ric"),
            "contract_name": obj.get("contractName"),
            "contract_year": obj.get("contractYear"),
            "contract_month": obj.get("contractMonth"),
            "strike": obj.get("strike"),
            "call_put_type": obj.get("callPutType")
        })
        return _obj

