# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_call_put_type import EnumsCallPutType
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_expiry_time import EnumsExpiryTime
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_option_style import EnumsOptionStyle

class ReferenceDataassetv1FxOptionSecurity(BaseModel):
    """
    ReferenceDataassetv1FxOptionSecurity
    """
    currency_pair: Optional[StrictStr] = Field(None, alias="currencyPair")
    expiration_date: Optional[date] = Field(None, alias="expirationDate")
    delivery_date: Optional[date] = Field(None, alias="deliveryDate")
    call_put_type: Optional[EnumsCallPutType] = Field(None, alias="callPutType")
    option_style: Optional[EnumsOptionStyle] = Field(None, alias="optionStyle")
    strike: Optional[Union[StrictFloat, StrictInt]] = None
    expiry_time: Optional[EnumsExpiryTime] = Field(None, alias="expiryTime")
    non_deliverable: Optional[StrictBool] = Field(None, alias="nonDeliverable")
    fx_rate_reference: Optional[StrictStr] = Field(None, alias="fxRateReference")
    lower_barrier: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="lowerBarrier", description="certain barrier events will need a lower barrier specified due to the event relating to a lower price dictating if the option can be exercised or not.")
    upper_barrier: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="upperBarrier", description="the upper barrier will need to be defined and populated if the option needs to either hit a certain barrier or avoid crossing that upper barrier.")
    barrier_start_date: Optional[date] = Field(None, alias="barrierStartDate", description="date that the barrier starts this will be the start date of the option and the start of the barrier event applicable if the time constraint for the barrier happens to differ from that full life of the option.")
    barrier_end_date: Optional[date] = Field(None, alias="barrierEndDate", description="date that the barrier ends this will be the maturity date of the option or the end of the barrier event applicable if the time constraint for the barrier happens to differ from that full life of the option.")
    barrier_source: Optional[StrictStr] = Field(None, alias="barrierSource")
    settlement_currency: Optional[StrictStr] = Field(None, alias="settlementCurrency")
    __properties = ["currencyPair", "expirationDate", "deliveryDate", "callPutType", "optionStyle", "strike", "expiryTime", "nonDeliverable", "fxRateReference", "lowerBarrier", "upperBarrier", "barrierStartDate", "barrierEndDate", "barrierSource", "settlementCurrency"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReferenceDataassetv1FxOptionSecurity:
        """Create an instance of ReferenceDataassetv1FxOptionSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReferenceDataassetv1FxOptionSecurity:
        """Create an instance of ReferenceDataassetv1FxOptionSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReferenceDataassetv1FxOptionSecurity.parse_obj(obj)

        _obj = ReferenceDataassetv1FxOptionSecurity.parse_obj({
            "currency_pair": obj.get("currencyPair"),
            "expiration_date": obj.get("expirationDate"),
            "delivery_date": obj.get("deliveryDate"),
            "call_put_type": obj.get("callPutType"),
            "option_style": obj.get("optionStyle"),
            "strike": obj.get("strike"),
            "expiry_time": obj.get("expiryTime"),
            "non_deliverable": obj.get("nonDeliverable"),
            "fx_rate_reference": obj.get("fxRateReference"),
            "lower_barrier": obj.get("lowerBarrier"),
            "upper_barrier": obj.get("upperBarrier"),
            "barrier_start_date": obj.get("barrierStartDate"),
            "barrier_end_date": obj.get("barrierEndDate"),
            "barrier_source": obj.get("barrierSource"),
            "settlement_currency": obj.get("settlementCurrency")
        })
        return _obj

