# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_fx_type import EnumsFXType

class ReferenceDataassetv1FxSecurity(BaseModel):
    """
    ReferenceDataassetv1FxSecurity
    """
    currency_pair: StrictStr = Field(..., alias="currencyPair")
    value_date: Optional[date] = Field(None, alias="valueDate")
    rate: Optional[Union[StrictFloat, StrictInt]] = None
    fx_type: Optional[EnumsFXType] = Field(None, alias="fxType")
    __properties = ["currencyPair", "valueDate", "rate", "fxType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReferenceDataassetv1FxSecurity:
        """Create an instance of ReferenceDataassetv1FxSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReferenceDataassetv1FxSecurity:
        """Create an instance of ReferenceDataassetv1FxSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReferenceDataassetv1FxSecurity.parse_obj(obj)

        _obj = ReferenceDataassetv1FxSecurity.parse_obj({
            "currency_pair": obj.get("currencyPair"),
            "value_date": obj.get("valueDate"),
            "rate": obj.get("rate"),
            "fx_type": obj.get("fxType")
        })
        return _obj

