# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.v1_swap_data import V1SwapData

class ReferenceDataassetv1InterestRateSwapSecurity(BaseModel):
    """
    ReferenceDataassetv1InterestRateSwapSecurity
    """
    swap_info: Optional[V1SwapData] = Field(None, alias="swapInfo")
    start_date: Optional[date] = Field(None, alias="startDate")
    maturity_date: Optional[date] = Field(None, alias="maturityDate")
    exchange: Optional[StrictStr] = Field(None, description="represents BILATERAL , LUK etc for example, If a swap is centrally cleared this field should be populated in accordance with relevant exchange. Check out the decodes table IRS_EXCHANGE for corresponding cde value to be used.")
    counterparty: Optional[StrictStr] = None
    __properties = ["swapInfo", "startDate", "maturityDate", "exchange", "counterparty"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReferenceDataassetv1InterestRateSwapSecurity:
        """Create an instance of ReferenceDataassetv1InterestRateSwapSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of swap_info
        if self.swap_info:
            _dict['swapInfo'] = self.swap_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReferenceDataassetv1InterestRateSwapSecurity:
        """Create an instance of ReferenceDataassetv1InterestRateSwapSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReferenceDataassetv1InterestRateSwapSecurity.parse_obj(obj)

        _obj = ReferenceDataassetv1InterestRateSwapSecurity.parse_obj({
            "swap_info": V1SwapData.from_dict(obj.get("swapInfo")) if obj.get("swapInfo") is not None else None,
            "start_date": obj.get("startDate"),
            "maturity_date": obj.get("maturityDate"),
            "exchange": obj.get("exchange"),
            "counterparty": obj.get("counterparty")
        })
        return _obj

