# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_pool_type import EnumsPoolType
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.v1_tba_data import V1TbaData

class ReferenceDataassetv1MbsTbaSecurity(BaseModel):
    """
    ReferenceDataassetv1MbsTbaSecurity
    """
    tba_info: Optional[V1TbaData] = Field(None, alias="tbaInfo")
    coupon: Optional[Union[StrictFloat, StrictInt]] = None
    pool_story: Optional[EnumsPoolType] = Field(None, alias="poolStory")
    __properties = ["tbaInfo", "coupon", "poolStory"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReferenceDataassetv1MbsTbaSecurity:
        """Create an instance of ReferenceDataassetv1MbsTbaSecurity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of tba_info
        if self.tba_info:
            _dict['tbaInfo'] = self.tba_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReferenceDataassetv1MbsTbaSecurity:
        """Create an instance of ReferenceDataassetv1MbsTbaSecurity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReferenceDataassetv1MbsTbaSecurity.parse_obj(obj)

        _obj = ReferenceDataassetv1MbsTbaSecurity.parse_obj({
            "tba_info": V1TbaData.from_dict(obj.get("tbaInfo")) if obj.get("tbaInfo") is not None else None,
            "coupon": obj.get("coupon"),
            "pool_story": obj.get("poolStory")
        })
        return _obj

