# coding: utf-8

"""
    Security Creation

    This service is used to create CDS, CDX, Equity Equity, Equity Option, Futures, FX NDF, FX SPOT, FX FWRD, FX CSWAP, FX Option, Swap, Swaption, CASH/TD, CASH/REPO, ARM/TBA and MBS/TBA securities.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from asdk_plugin_data.agraph.data.reference_data.asset.asset_creation.v1.SecurityCreationAPI.models.enums_dealer_role import EnumsDealerRole

class V1SyndicateData(BaseModel):
    """
    V1SyndicateData
    """
    dealer: StrictStr = Field(...)
    dealer_role: Optional[EnumsDealerRole] = Field(None, alias="dealerRole")
    percentage_fee: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="percentageFee", description="Fee Percentage - Underwriting fee earned by dealer in currency denominations.")
    proceeds_used: Optional[StrictBool] = Field(None, alias="proceedsUsed")
    __properties = ["dealer", "dealerRole", "percentageFee", "proceedsUsed"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1SyndicateData:
        """Create an instance of V1SyndicateData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1SyndicateData:
        """Create an instance of V1SyndicateData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1SyndicateData.parse_obj(obj)

        _obj = V1SyndicateData.parse_obj({
            "dealer": obj.get("dealer"),
            "dealer_role": obj.get("dealerRole"),
            "percentage_fee": obj.get("percentageFee"),
            "proceeds_used": obj.get("proceedsUsed")
        })
        return _obj

